
// productions which match indentation-balanced text regions; that is,
// regions in which the indentation level of all parts of the region
// is strictly non-negative relative to the start of the region.

// A region which is indentation-balanced: no prefix of the region
// contains more outdents than indents.
Balanced!           = Balanced ~[>><<]
                    | Balanced >> Balanced <<
                    | ()

// A region which is unbalanced: some prefix has more outdents than
// indents.  May be faster to match than (~~Balanced).
UnBalanced!         = <<
                    | ~[>><<] UnBalanced
                    | >> UnBalanced UnBalanced
